// ILDoslinkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ILDoslink.h"
#include "ILDoslinkDlg.h"
#include "IlSetup.h"
#include "TcpIp.h"
#include "DoslinkDev.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define VERSION   "1.06"

extern CILDoslinkApp theApp;

#ifdef _DEBUG
LPCTSTR szNoTitle = _T("ILDosLink ")_T(VERSION)_T(" Debug");
#else
LPCTSTR szNoTitle = _T("ILDosLink ")_T(VERSION);
#endif

static const LPCTSTR szLicence =
	_T("This program is free software; you can redistribute it and/or modify\r\n")
	_T("it under the terms of the GNU General Public License as published by\r\n")
	_T("the Free Software Foundation; either version 2 of the License, or\r\n")
	_T("(at your option) any later version.\r\n")
	_T("\r\n")
	_T("This program is distributed in the hope that it will be useful,\r\n")
	_T("but WITHOUT ANY WARRANTY; without even the implied warranty of\r\n")
	_T("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\r\n")
	_T("See the GNU General Public License for more details.\r\n")
	_T("\r\n")
	_T("You should have received a copy of the GNU General Public License along\r\n")
	_T("with this program; if not, write to the Free Software Foundation, Inc.,\r\n")
	_T("51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.");

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	SetDlgItemText(IDC_VERSION,szNoTitle);
	SetDlgItemText(IDC_LICENSE,szLicence);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CILDoslinkDlg dialog

CILDoslinkDlg::CILDoslinkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CILDoslinkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CILDoslinkDlg)
	m_strInFile = _T("");
	m_strOutFile = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_strAddrOut = _T("localhost");
	m_uPortOut   = 60000;
	m_uPortIn    = 60001;

	m_dwConnectTimeout = 0xFFFFFFFF;		// client connect timeout in us (default blocked connect timeout)

	m_strOutFile = _T("outfile.dat");
	m_strInFile  = _T("infile.dat");

	m_pComObj = NULL;
	m_pDosLink = NULL;
}

CILDoslinkDlg::~CILDoslinkDlg()
{
	delete m_pDosLink;						// delete the DOSLINK device
}

/////////////////////////////////////////////////////////////////////////////
// CILVideoDlg settings helper functions

CString CILDoslinkDlg::ReadString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR cBuffer[1024];

		::GetPrivateProfileString(lpszSection,lpszEntry,lpszDefault,cBuffer,ARRAYSIZEOF(cBuffer),theApp.m_szIniFile);
		return CString(cBuffer);
	}
	else
	{
		return AfxGetApp()->GetProfileString(lpszSection,lpszEntry,lpszDefault);
	}
}

UINT CILDoslinkDlg::ReadInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::GetPrivateProfileInt(lpszSection,lpszEntry,nDefault,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->GetProfileInt(lpszSection,lpszEntry,nDefault);
	}
}

BOOL CILDoslinkDlg::WriteString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::WritePrivateProfileString(lpszSection,lpszEntry,lpszValue,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileString(lpszSection,lpszEntry,lpszValue);
	}
}

BOOL CILDoslinkDlg::WriteInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR s[16];
		wsprintf(s,_T("%u"),nValue);
		return ::WritePrivateProfileString(lpszSection,lpszEntry,s,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileInt(lpszSection,lpszEntry,nValue);
	}
}

void CILDoslinkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CILDoslinkDlg)
	DDX_Control(pDX, IDC_STOP, m_CButStop);
	DDX_Control(pDX, IDC_START, m_CButStart);
	DDX_Text(pDX, IDC_INFILE, m_strInFile);
	DDX_Text(pDX, IDC_OUTFILE, m_strOutFile);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CILDoslinkDlg, CDialog)
	ON_MESSAGE(WM_INTERFACESTOPPED, OnInterfaceStopped)

	//{{AFX_MSG_MAP(CILDoslinkDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_BROWSE_OUT, OnBrowseOut)
	ON_BN_CLICKED(IDC_BROWSE_IN, OnBrowseIn)
	ON_BN_CLICKED(IDC_CLOSEALL, OnCloseall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CILDoslinkDlg message handlers

BOOL CILDoslinkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "TCP/IP Setup...", "Help Topics..."
	// and "About ILVideo..." menu items to the system menu.

	// IDM_HPILSETUP must be in the system command range.
	ASSERT((IDM_HPILSETUP & 0xFFF0) == IDM_HPILSETUP);
	ASSERT(IDM_HPILSETUP < 0xF000);

	// IDM_HELPTOPICS must be in the system command range.
	ASSERT((IDM_HELPTOPICS & 0xFFF0) == IDM_HELPTOPICS);
	ASSERT(IDM_HELPTOPICS < 0xF000);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strText;
		pSysMenu->AppendMenu(MF_SEPARATOR);

		strText.LoadString(IDS_TCPIP_SETTING);
		pSysMenu->AppendMenu(MF_STRING, IDM_HPILSETUP, strText);

		strText.LoadString(IDS_HELP_TOPICS);
		pSysMenu->AppendMenu(MF_STRING, IDM_HELPTOPICS, strText);

		strText.LoadString(IDS_ABOUTBOX);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strText);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_CButStart.EnableWindow(TRUE);
	m_CButStop.EnableWindow(FALSE);

	if (*theApp.m_szIniFile != 0)			// ini file given
	{
		CString strTitle,strAppTitle;

		// new document title
		GetWindowText(strAppTitle);
		strTitle.Format(_T("%s - %s"),strAppTitle,theApp.m_lpFilePart);
		SetWindowText(strTitle);			// set document title with ini file
	}

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);

	// load positions from registry if available
	m_nPosX      = ReadInt(_T("Settings"),_T("WinPosX"),wndpl.rcNormalPosition.left);
	m_nPosY      = ReadInt(_T("Settings"),_T("WinPosY"),wndpl.rcNormalPosition.top);

	m_strOutFile = ReadString(_T("Settings"),_T("FileOut"),m_strOutFile);
	m_strInFile  = ReadString(_T("Settings"),_T("FileIn"),m_strInFile);

	// TCP/IP settings
	m_strAddrOut = ReadString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	m_uPortOut   = ReadInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	m_uPortIn    = ReadInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	m_dwConnectTimeout = ReadInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);

	SetWindowLocation(m_nPosX,m_nPosY);		// set windows location

	// create the DOSLINK instrument class
	m_pDosLink = new CDosLinkDev(m_strOutFile,m_strInFile);

	UpdateData(FALSE);

	// press the "Start" button
	if (theApp.m_bStart) PostMessage(WM_COMMAND,IDC_START);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CILDoslinkDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE)
	{
		return TRUE;  // disable the ESC key quitting the application
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CILDoslinkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	switch (nID & 0xFFF0)
	{
	case IDM_HPILSETUP:
	{
		CILSetup dlg(m_strAddrOut,m_uPortOut,m_uPortIn);
		if (IDOK == dlg.DoModal())
		{
			dlg.GetData(m_strAddrOut,m_uPortOut,m_uPortIn);
		}
		break;
	}
	case IDM_HELPTOPICS:
		ShellExecute(GetSafeHwnd(),
					 _T("open"),
					 _T("ILDoslink.htm"),
					 NULL,
					 _T(""),
					 SW_SHOWNORMAL);
		break;
	case IDM_ABOUTBOX:
		CAboutDlg().DoModal();
		break;
	default:
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CILDoslinkDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CILDoslinkDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// set window location
VOID CILDoslinkDlg::SetWindowLocation(INT nPosX,INT nPosY)
{
	WINDOWPLACEMENT wndpl;
	RECT *pRc = &wndpl.rcNormalPosition;

	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	pRc->right = pRc->right - pRc->left + nPosX;
	pRc->bottom = pRc->bottom - pRc->top + nPosY;
	pRc->left = nPosX;
	pRc->top = nPosY;
	SetWindowPlacement(&wndpl);
	return;
}

void CILDoslinkDlg::OnBrowseOut() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog dlg(
		TRUE,
		NULL,
		m_strOutFile,
		OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,
		_T("Data Files (*.dat)|*.dat|All Files (*.*)|*.*||"));

	if (IDOK == dlg.DoModal())
	{
		m_strOutFile = dlg.GetPathName();

		// set file name for out file
		m_pDosLink->SetOutFile(m_strOutFile);
	}
	UpdateData(FALSE);	
}

void CILDoslinkDlg::OnBrowseIn() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog dlg(
		TRUE,
		NULL,
		m_strInFile,
		OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,
		_T("Data Files (*.dat)|*.dat|All Files (*.*)|*.*||"));

	if (IDOK == dlg.DoModal())
	{
		m_strInFile = dlg.GetPathName();

		// set file name for out file
		m_pDosLink->SetInFile(m_strInFile);
	}
	UpdateData(FALSE);	
}

void CILDoslinkDlg::OnCloseall()
{
	// TODO: Add your control notification handler code here
	m_pDosLink->ClearDevice();
}

void CILDoslinkDlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	m_pDosLink->SetOutFile(m_strOutFile);
	m_pDosLink->SetInFile(m_strInFile);

	m_pComObj = new CTcpIp(m_pDosLink,m_strAddrOut,m_uPortOut,m_uPortIn,m_dwConnectTimeout,this);
	if (m_pComObj != NULL)
	{
		if (m_pComObj->StartServer() == true) // init server
		{
			GetDlgItem(IDC_OUTFILE)->EnableWindow(FALSE);
			GetDlgItem(IDC_INFILE)->EnableWindow(FALSE);

			m_CButStart.SetButtonStyle(BS_PUSHBUTTON);
			m_CButStart.EnableWindow(FALSE);
			m_CButStop.EnableWindow(TRUE);
			m_CButStop.SetButtonStyle(BS_DEFPUSHBUTTON);
			m_CButStop.SetFocus();
		}
		else								// error
		{
			ASSERT(m_pComObj);				// free Interface class
			delete m_pComObj;
			m_pComObj = NULL;
		}
	}
}

void CILDoslinkDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	ASSERT(m_pComObj != NULL);
	m_pComObj->StopServer();				// quit server thread
}

LRESULT CILDoslinkDlg::OnInterfaceStopped(WPARAM wParam,LPARAM lParam)
{
	// quit message from Interface worker thread
	CInterface *pComObj = reinterpret_cast<CInterface *>(wParam);
	ASSERT(pComObj == m_pComObj);

	ASSERT(m_pComObj);
	delete m_pComObj;
	m_pComObj = NULL;

	GetDlgItem(IDC_OUTFILE)->EnableWindow();
	GetDlgItem(IDC_INFILE)->EnableWindow();

	m_CButStop.SetButtonStyle(BS_PUSHBUTTON);
	m_CButStop.EnableWindow(FALSE);
	m_CButStart.EnableWindow(TRUE);
	m_CButStart.SetButtonStyle(BS_DEFPUSHBUTTON);
	m_CButStart.SetFocus();
	return 0;
	UNREFERENCED_PARAMETER(wParam);
	UNREFERENCED_PARAMETER(lParam);
}

void CILDoslinkDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if (m_pComObj != NULL)					// Interface running
	{
		OnStop();
		PostMessage(WM_COMMAND,IDCANCEL,0);	// call myself, until thread finished
		return;
	}

	// save current settings
	UpdateData(TRUE);

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	m_nPosX = wndpl.rcNormalPosition.left;
	m_nPosY = wndpl.rcNormalPosition.top;

	TCHAR szAppFile[_MAX_PATH];				// full pathname of application
	GetModuleFileName(NULL,szAppFile,ARRAYSIZEOF(szAppFile));
	WriteString(_T("Run"),_T("App"),szAppFile);

	WriteInt(_T("Settings"),_T("WinPosX"),m_nPosX);
	WriteInt(_T("Settings"),_T("WinPosY"),m_nPosY);

	WriteString(_T("Settings"),_T("FileOut"),m_strOutFile);
	WriteString(_T("Settings"),_T("FileIn"),m_strInFile);

	// TCP/IP settings
	WriteString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	WriteInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	WriteInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	WriteInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);

	CDialog::OnCancel();
}
